#include "universal.hpp"
#include "components.hpp"

Component::Component(Designator dsgntr, Node *nd1, Node *nd2, Node *nd3)
{
  designator = dsgntr;
  node1 = nd1;
  node2 = nd2;
  node3 = nd3;
}

Component::Component(Designator dsgntr, Node *nd1, Node *nd2)
{
  designator = dsgntr;
  node1 = nd1;
  node2 = nd2;
}

double Component::calc_voltage(vector<double> V)
{
  vector<double> V_aug = V;
  reverse(V_aug.begin(), V_aug.end());
  V_aug.push_back(0);
  reverse(V_aug.begin(), V_aug.end());

  return V_aug[node1->id] - V_aug[node2->id];
}

Node* Component::get_node1()
{
  return node1;
}
Node* Component::get_node2()
{
  return node2;
}

Designator Component::get_designator()
{
  return designator;
}

double Component::get_current()
{
  return current;
}

pair<double, double> Component::update_V_I(vector<double> V)
{
  throw logic_error("SHOULD NOT EVER RUN");
  return make_pair(-1, -1);
}

pair<double, double> Component::update_V_I(vector<double> V, double t_step)
{
  throw logic_error("SHOULD NOT EVER RUN");
  return make_pair(-1, -1);
}