#include "components.hpp"

/****************************** InputSource Class *****************************/
InputSource::InputSource(Designator dsgntr, Node *nd1, Node *nd2, double offset,
                         double Amplitude, double freq)
                         : Component(dsgntr, nd1, nd2)
{
  A = Amplitude;
  off = offset;
  f = freq;
}

void InputSource::update_offset(double offset)
{
  this->off = offset;
}

double InputSource::get_offset() const
{
  return off;
}
double InputSource::get_frequency() const
{
  return f;
}
double InputSource::get_amplitude() const
{
  return A;
}

double InputSource::get_value(double t) const
{
  return off + A * sin(2 * 3.14 * f * t);
}


/***************************** VoltageSource Class ****************************/
VoltageSource::VoltageSource(Node *nd1, Node *nd2, double offset,
                             double Amplitude, double freq)
: InputSource(Designator::Voltage, nd1, nd2, offset, Amplitude, freq)
{
  node1->update_connected_to_Vsrc(true);
  node2->update_connected_to_Vsrc(true);
}

/***************************** CurrentSource Class ****************************/
CurrentSource::CurrentSource(Node *nd1, Node *nd2, double offset,
                             double Amplitude, double freq)
: InputSource(Designator::Current, nd1, nd2, offset, Amplitude, freq) {}