#ifndef NODE_H
#define NODE_H

#include "universal.hpp"

class Node
{
private:
  bool connected_to_Vsrc;
  bool prev_connected_to_Vsrc;
  vector<bool> neighbors;

public:
  int id;

  Node(int node_id, bool connected_to_Vsrc);
  Node(const Node &node);
  Node(); 

  bool operator==(const Node &node) const;
  bool operator!=(const Node &node) const;

  bool is_reference();

  bool is_connected_to_Vsrc();
  void update_connected_to_Vsrc(bool connected_to_Vsrc);
  void restore_is_connected_to_Vsrc();

  bool has_neighbor(Node *node);
  vector<bool> get_neighbors();
  void update_neighbors(Node *neighbor);
  void extend_neighbors(int nodes_num);
};

#endif