#ifndef PARSER_H
#define PARSER_H

#include "universal.hpp"
#include "types_etc.hpp"

class Parser
{
public:
  Parser(string filename);

  tuple<char, Node *, Node *, double> parse_impedance_line(string line);
  Resistor *parse_resistor_line(string line);
  DynamicImpedanceDevice *parse_dynamic_impedance_line(string line);
  InputSource *parse_source_line(string line);
  NonLinearDevice *parse_non_linear_line(string line);
  pair<double, double> parse_time(string line);

  Resistors resistors;
  DynamicImpedanceDevices d_impdnc_devs;
  NonLinearDevices nn_devs;
  InputSources in_srcs;
  Nodes nodes;
  double t_stop, t_step;

private:
  int nb_digits(double value);
  Node *get_node(int node_id);
  int calc_mult(char multipl);
};

#endif