import numpy as np
from matplotlib import pyplot as plt

def plot_solution(filename, ax = None):
    with open(filename, 'r') as reader:
        solution = reader.read()
        solution = solution.split("---")
        solution = [[float(volt.strip()) for volt in s.strip().split("\n")]
                    for s in solution
                    if len(s.strip()) > 0]

        solution = np.array(solution)

    if ax == None:
        fig, ax = plt.subplots(figsize=(20, 10))

    for i in range(len(solution[0])):
        ax.plot(solution[:, i], label=f"Node {i+1}")
    ax.set_ylabel("Voltage", fontsize=14)
    ax.set_xlabel("timestep", fontsize=14)
    ax.grid()
    ax.legend()

if __name__ == "__main__":
    fig, ax1 = plt.subplots(1, 1, sharey=True, figsize=(20, 10))

    plot_solution("solution.txt", ax1)
    # plot_solution("solution_L.txt", ax2)
    # plot_solution("solution_striped.txt", ax3)
    plt.show()